# 1. Initialize Upload: https://www.googleapis.com/upload/youtube/v3/videos?part=snippet,status&uploadType=resumable POST https://graph.facebook.com/upload/youtube/v3/videos Content-Type: application/json Reference: https://docs.deao.dev/cloudflare/social-media-posting/you-tube/1-initialize-upload-https-www-googleapis-com-upload-youtube-v-3-videos-part-snippet-status-upload-type-resumable ## OpenAPI Specification ```yaml openapi: 3.1.0 info: title: collection version: 1.0.0 paths: /upload/youtube/v3/videos: post: operationId: >- 1-initialize-upload-https-www-googleapis-com-upload-youtube-v-3-videos-part-snippet-status-upload-type-resumable summary: >- 1. Initialize Upload: https://www.googleapis.com/upload/youtube/v3/videos?part=snippet,status&uploadType=resumable tags: - subpackage_socialMediaPosting.subpackage_socialMediaPosting/youTube parameters: - name: part in: query required: false schema: type: string - name: uploadType in: query required: false schema: type: string - name: X-Upload-Content-Type in: header required: false schema: type: string - name: X-Upload-Content-Length in: header description: '{x_upload_content_length}' required: false schema: type: string responses: '200': description: OK content: application/json: schema: $ref: >- #/components/schemas/Social Media Posting_YouTube_1. Initialize Upload: https://www.googleapis.com/upload/youtube/v3/videos?part=snippet,status&uploadType=resumable_Response_200 requestBody: content: application/json: schema: type: string servers: - url: https://graph.facebook.com - url: https://www.youtube.com - url: https://youtube-video-summarizer-gpt-ai.p.rapidapi.com - url: https://api.cloudflare.com - url: https://dev-musiccast.odoo.com - url: https://api.search.brave.com - url: https://og-image-generator-dev.deao.workers.dev - url: https://musiccast.odoo.com - url: https://m.musicca.st - url: https://api.stripe.com - url: https://api.kie.ai - url: https://api.pexels.com - url: https://api.shotstack.io - url: https://oauth2.googleapis.com - url: https://www.googleapis.com - url: https://api.linkedin.com - url: https://www.linkedin.com - url: https://rupload.facebook.com - url: https://api.x.com - url: https://open.tiktokapis.com - url: https://open-upload-sg.tiktokapis.com - url: https://social-media-posting-dev.deao.workers.dev components: schemas: 'Social Media Posting_YouTube_1. Initialize Upload: https://www.googleapis.com/upload/youtube/v3/videos?part=snippet,status&uploadType=resumable_Response_200': type: object properties: {} description: Empty response body title: >- Social Media Posting_YouTube_1. Initialize Upload: https://www.googleapis.com/upload/youtube/v3/videos?part=snippet,status&uploadType=resumable_Response_200 ``` ## SDK Code Examples ```python import requests url = "https://graph.facebook.com/upload/youtube/v3/videos" querystring = {"part":"snippet,status","uploadType":"resumable"} payload = "{ \"snippet\": { \"title\": \"tttttmi short\", // {title} \"description\": \"hello world- https://musicca.st\" // {message} }, \"status\": { \"privacyStatus\": \"public\" } }" headers = { "X-Upload-Content-Type": "video/mp4", "X-Upload-Content-Length": "7420640", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers, params=querystring) print(response.json()) ``` ```javascript const url = 'https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable'; const options = { method: 'POST', headers: { 'X-Upload-Content-Type': 'video/mp4', 'X-Upload-Content-Length': '7420640', 'Content-Type': 'application/json' }, body: '"{\n \"snippet\": {\n \"title\": \"tttttmi short\", // {title}\n \"description\": \"hello world- https://musicca.st\" // {message}\n },\n \"status\": {\n \"privacyStatus\": \"public\"\n }\n}"' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable" payload := strings.NewReader("\"{\\n \\\"snippet\\\": {\\n \\\"title\\\": \\\"tttttmi short\\\", // {title}\\n \\\"description\\\": \\\"hello world- https://musicca.st\\\" // {message}\\n },\\n \\\"status\\\": {\\n \\\"privacyStatus\\\": \\\"public\\\"\\n }\\n}\"") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("X-Upload-Content-Type", "video/mp4") req.Header.Add("X-Upload-Content-Length", "7420640") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["X-Upload-Content-Type"] = 'video/mp4' request["X-Upload-Content-Length"] = '7420640' request["Content-Type"] = 'application/json' request.body = "\"{\\n \\\"snippet\\\": {\\n \\\"title\\\": \\\"tttttmi short\\\", // {title}\\n \\\"description\\\": \\\"hello world- https://musicca.st\\\" // {message}\\n },\\n \\\"status\\\": {\\n \\\"privacyStatus\\\": \\\"public\\\"\\n }\\n}\"" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable") .header("X-Upload-Content-Type", "video/mp4") .header("X-Upload-Content-Length", "7420640") .header("Content-Type", "application/json") .body("\"{\\n \\\"snippet\\\": {\\n \\\"title\\\": \\\"tttttmi short\\\", // {title}\\n \\\"description\\\": \\\"hello world- https://musicca.st\\\" // {message}\\n },\\n \\\"status\\\": {\\n \\\"privacyStatus\\\": \\\"public\\\"\\n }\\n}\"") .asString(); ``` ```php request('POST', 'https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable', [ 'body' => '"{\\n \\"snippet\\": {\\n \\"title\\": \\"tttttmi short\\", // {title}\\n \\"description\\": \\"hello world- https://musicca.st\\" // {message}\\n },\\n \\"status\\": {\\n \\"privacyStatus\\": \\"public\\"\\n }\\n}"', 'headers' => [ 'Content-Type' => 'application/json', 'X-Upload-Content-Length' => '7420640', 'X-Upload-Content-Type' => 'video/mp4', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable"); var request = new RestRequest(Method.POST); request.AddHeader("X-Upload-Content-Type", "video/mp4"); request.AddHeader("X-Upload-Content-Length", "7420640"); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "\"{\\n \\\"snippet\\\": {\\n \\\"title\\\": \\\"tttttmi short\\\", // {title}\\n \\\"description\\\": \\\"hello world- https://musicca.st\\\" // {message}\\n },\\n \\\"status\\\": {\\n \\\"privacyStatus\\\": \\\"public\\\"\\n }\\n}\"", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "X-Upload-Content-Type": "video/mp4", "X-Upload-Content-Length": "7420640", "Content-Type": "application/json" ] let parameters = "{ \"snippet\": { \"title\": \"tttttmi short\", // {title} \"description\": \"hello world- https://musicca.st\" // {message} }, \"status\": { \"privacyStatus\": \"public\" } }" as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://graph.facebook.com/upload/youtube/v3/videos?part=snippet%2Cstatus&uploadType=resumable")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```